<template>
  <div class="app-container">

    <!-- 查询和其他操作 -->
    <div class="filter-container">
      <el-input v-model="listQuery.name" clearable class="filter-item" style="width: 200px;" placeholder="请输入门店" />
      <el-button v-permission="['GET /admin/department/list']" class="filter-item" type="primary" icon="el-icon-search" @click="handleFilter">查找</el-button>
      <el-button v-permission="['POST /admin/department/create']" class="filter-item" type="primary" icon="el-icon-edit" @click="handleCreate">添加</el-button>
    </div>

    <!-- 查询结果 -->
    <el-table v-loading="listLoading" :data="list" element-loading-text="正在查询中。。。" border fit highlight-current-row>
      <el-table-column align="center" label="编号" prop="id" sortable />

      <el-table-column align="center" label="处理结果" prop="name" />

      <el-table-column align="center" label="对应工单类型" prop="type">
        <template slot-scope="scope">
          <el-tag :type="scope.row.type==0 ? 'success' : 'error' ">{{ scope.row.type==0 ? '咨询' : '投诉' }}</el-tag>
        </template>
      </el-table-column>

      <el-table-column align="center" label="是否需要写备注" prop="isNeedMemo">
        <template slot-scope="scope">
          <span v-if="scope.row.isNeedMemo == true">需要</span>
          <span v-else>不需要</span>
        </template>
      </el-table-column>

      <el-table-column align="center" label="状态" prop="deleted">
        <template slot-scope="scope">
          <span v-if="scope.row.deleted == true">已停用</span>
          <span v-else>正常</span>
        </template>
      </el-table-column>

      <el-table-column align="center" label="操作" width="250" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button v-permission="['POST /admin/department/update']" type="primary" size="mini" @click="handleUpdate(scope.row)">编辑</el-button>
          <el-button v-permission="['POST /admin/department/delete']" type="danger" size="mini" @click="handleDelete(scope.row)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" :page.sync="listQuery.page" :limit.sync="listQuery.limit" @pagination="getList" />

    <!-- 添加或修改对话框 -->
    <el-dialog :title="textMap[dialogStatus]" :visible.sync="dialogFormVisible">
      <el-form ref="dataForm" :rules="rules" :model="dataForm" status-icon label-position="left" label-width="100px" style="width: 400px; margin-left:50px;">
        <el-form-item label="处理结果" prop="name">
          <el-input v-model="dataForm.name" />
        </el-form-item>

        <el-form-item label="对应工单类型" prop="type">
          <el-radio-group v-model="dataForm.type">
            <el-radio :label="0">咨询</el-radio>
            <el-radio :label="1">投诉</el-radio>
          </el-radio-group>
        </el-form-item>

        <el-form-item label="是否需要备注" prop="isNeedMemo">
          <el-radio-group v-model="dataForm.isNeedMemo">
            <el-radio :label="true">是</el-radio>
            <el-radio :label="false">否</el-radio>
          </el-radio-group>
        </el-form-item>

        <el-form-item label="状态" prop="deleted">
          <el-select v-model="dataForm.deleted" clearable style="width: 200px" class="filter-item" placeholder="请选择状态">
            <el-option v-for="type in deletedOptions" :key="type.value" :label="type.label" :value="type.value" />
          </el-select>
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取消</el-button>
        <el-button v-if="dialogStatus=='create'" type="primary" @click="createData">确定</el-button>
        <el-button v-else type="primary" @click="updateData">确定</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
import { listTicketResult, createTicketResult, updateTicketResult, deleteTicketResult } from '@/api/ticketResult'
import Pagination from '@/components/Pagination' // Secondary package based on el-pagination
let vm

export default {
  name: 'TicketResult',
  components: { Pagination },
  data() {
    return {
      list: null,
      total: 0,
      listLoading: true,
      listQuery: {
        name: undefined,
        page: 1,
        limit: 20,
        sort: 'create_time',
        order: 'desc'
      },
      dataForm: {
        id: undefined,
        name: '',
        deleted: false,
        isNeedMemo: false,
        type: 0
      },
      deletedOptions: [{
        value: false,
        label: '正常'
      }, {
        value: true,
        label: '删除'
      }],
      dialogFormVisible: false,
      dialogStatus: '',
      textMap: {
        update: '编辑',
        create: '创建'
      },
      rules: {
        name: [{ required: true, message: '内容不能为空', trigger: 'blur' }]
      },
      downloadLoading: false
    }
  },
  beforeCreate() {
    vm = this
  },
  created() {
    this.getList()
  },
  methods: {
    getList() {
      this.listLoading = true
      listTicketResult(this.listQuery).then(response => {
        this.list = response.data.data.list
        this.total = response.data.data.total
        this.listLoading = false
      }).catch(() => {
        this.list = []
        this.total = 0
        this.listLoading = false
      })
    },
    handleFilter() {
      this.listQuery.page = 1
      this.getList()
    },
    resetForm() {
      this.dataForm = {
        id: undefined,
        name: '',
        deleted: false,
        isNeedMemo: false,
        type: 0
      }
    },
    handleCreate() {
      this.resetForm()
      this.dialogStatus = 'create'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },
    createData() {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          createTicketResult(this.dataForm).then(response => {
            this.list.unshift(response.data.data)
            this.dialogFormVisible = false
            this.$notify.success({
              title: '成功',
              message: '创建成功'
            })
          }).catch(response => {
            this.$notify.error({
              title: '失败',
              message: response.data.errmsg
            })
          })
        }
      })
    },
    handleUpdate(row) {
      this.dataForm = Object.assign({}, row)
      this.dialogStatus = 'update'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },
    updateData() {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          updateTicketResult(this.dataForm).then(() => {
            for (const v of this.list) {
              if (v.id === this.dataForm.id) {
                const index = this.list.indexOf(v)
                this.list.splice(index, 1, this.dataForm)
                break
              }
            }
            this.dialogFormVisible = false
            this.$notify.success({
              title: '成功',
              message: '更新成功'
            })
          }).catch(response => {
            this.$notify.error({
              title: '失败',
              message: response.data.errmsg
            })
          })
        }
      })
    },
    handleDelete(row) {
      deleteTicketResult(row).then(response => {
        this.$notify.success({
          title: '成功',
          message: '删除成功'
        })
        const index = this.list.indexOf(row)
        this.list.splice(index, 1)
      }).catch(response => {
        this.$notify.error({
          title: '失败',
          message: response.data.errmsg
        })
      })
    }
  }
}
</script>
